/* Select the card type */
#ifndef _STOPWATCH_H
#define _STOPWATCH_H

#include <ucos.h>
#include <stdio.h>
#define LOGME iprintf("We got to line %d in file %s\r\n",__LINE__ , __FILE__ ); OSTimeDly(2);

#define DEFAULT_TIMER (1)

void StopWatchInit(int Timer = DEFAULT_TIMER, double InterruptTime = 0, WORD Prescaler = 0x0);
void StopWatchStart(int Timer = DEFAULT_TIMER);
DWORD StopWatchReadLow(int Timer = DEFAULT_TIMER);
DWORD StopWatchReadHigh(int Timer = DEFAULT_TIMER);
double StopWatchReadTime(int Timer = DEFAULT_TIMER);
void StopWatchStop(int Timer = DEFAULT_TIMER);
void StopWatchStopClear(int Timer = DEFAULT_TIMER);

void StopWatchDelay(double DelayTime, int Timer = DEFAULT_TIMER);
void StopWatchPollingDelay(double DelayTime, int Timer = DEFAULT_TIMER);

void StopWatchClockGenerator(double Frequency, int Timer = DEFAULT_TIMER);
int StopWatchPWMGenerator( double Period, double DutyCycle, int Timer = DEFAULT_TIMER ); //Period is set in Hz; Duty Cycle is set in Percent
extern void (*PWM_GPIO_PIN_HIGH_CALLBACK)();   // Points to user function that sets DMA Timer pin high in GPIO for PWM generation
extern void (*PWM_GPIO_PIN_LOW_CALLBACK)();    // Points to user function that sets DMA Timer pin low in GPIO for PWM generation
extern void (*DMA_PIN_TIMER_FUNC_CALLBACK)();  // Points to user function that sets DMA Timer pin to DMA Timer Output function for PWM and Clock generation

extern void (*StopWatch_Interrupt_Function)(int Timer);

#if (defined MCF5282 || defined MCF5213)
#define NB_CPU_CLK      ( 66355200 )
#elif defined MCF5272
#define NB_CPU_CLK      (62500000)
#elif defined MCF5208
#define NB_CPU_CLK      ( 83335000 )
#elif defined MCF53017
#define NB_CPU_CLK      ( 80000000 )
#elif (defined MCF5234 || defined MCF5270)
#define NB_CPU_CLK      ( 73728000 )
#else
#error PROCESSOR NOT DEFINED
#endif
#define TIME_PER_CLK (1.0 / NB_CPU_CLK)

#endif   /* _STOPWATCH_H */
